if(ThingsToDo2 == nil) then
	ThingsToDo2 = {}
end
local ttd2 = ThingsToDo2

if(ttd2.option == nil) then
	ttd2.option = {}
end
local option = ttd2.option

if(ttd2.lib == nil) then
	ttd2.lib = {}
end
local lib = ttd2.lib

lib.recipe = {}
local this = lib.recipe

this.private = { set = false }
function this.private.Validate()
	if(this.private.set == false) then
		this.private.Init()
		this.private.set = true
	end
	return
end

function this.private.Init()
	if(this.private.set == true) then
		return
	end
	
	this.LearnedString = ITEM_SPELL_KNOWN
	
	return
end

function this.IsRecipeInfoAvailable(RecipeItemID)
	this.private.Validate()
	
	lib.tooltip.RequestItemByID(RecipeItemID)
		
	return lib.tooltip.IsReady()
end

function this.IsRecipeLearned(RecipeItemID)
	this.private.Validate()
	
	lib.tooltip.RequestItemByID(RecipeItemID)
	
	if(lib.tooltip.IsReady() == false) then
		lib.chat.error(this.Name..": recipe tooltip was not ready: "..RecipeItemID)
		return false
	end
	
	local Lines = lib.tooltip.GetTextLines()
	
	local NumLines = #Lines
	for i=NumLines, 1, -1 do
		if(Lines[i] == this.LearnedString) then
			return true
		end
	end
	
	return false
end
