if(ThingsToDo2 == nil) then
	ThingsToDo2 = {}
end
local ttd2 = ThingsToDo2

if(ttd2.option == nil) then
	ttd2.option = {}
end
local option = ttd2.option

if(ttd2.lib == nil) then
	ttd2.lib = {}
end
local lib = ttd2.lib

if(ttd2.mod == nil) then
	ttd2.mod = {}
end
local mod = ttd2.mod

--this module
ttd2.ArchRestore = {}
local this = ttd2.ArchRestore
this.Name = "[Arch] Restore"

--[[
the purpose of this module is to restore the first archaeology artifact found in inventory each click on the button
]]

this.private = { set = false }
function this.private.Validate()
	if(this.private.set == false) then
		this.private.Init()
		this.private.set = true
	end
	return
end

function this.private.Init()
	if(this.private.set == true) then
		return
	end
	
	return
end

function this.private.Update()
	this.private.Validate()
	
	local out = lib.chat.output
	out.ClearBuffer()	
	--out.StoreDone("PLACEHOLDER")

	return
end

function this.CheckStatus()
	this.private.Validate()
	
	this.private.Update()
	if(lib.chat.output.GetNumLines() == 0) then
		return false
	end
	
	return true
end

function this.Script()
	this.private.Validate()
	
	this.private.Update()
	lib.chat.output.PrintModule(this.Name)
	
	return
end

mod[#mod+1] =
{
	CheckStatus	= this.CheckStatus,
	Text		= this.Name,
	Script		= this.Script
}
