if(ThingsToDo2 == nil) then
	ThingsToDo2 = {}
end
local ttd2 = ThingsToDo2

if(ttd2.option == nil) then
	ttd2.option = {}
end
local option = ttd2.option

if(ttd2.lib == nil) then
	ttd2.lib = {}
end
local lib = ttd2.lib

if(ttd2.mod == nil) then
	ttd2.mod = {}
end
local mod = ttd2.mod

--this module
ttd2.BFAMissions = {}
local this = ttd2.BFAMissions
this.Name = "[BFA] Missions"

this.private = { set = false }
function this.private.Validate()
	if(this.private.set == false) then
		this.private.Init()
		this.private.set = true
	end
	return
end

function this.private.Init()
	if(this.private.set == true) then
		return
	end
	
	--old
	--[[
	this.private.missions = {}	
	local missions = this.private.missions
	missions[1885] = {AchievementID = 12896, CriteriaID = 41140}
	missions[1886] = {AchievementID = 12896, CriteriaID = 41141}
	missions[1890] = {AchievementID = 12896, CriteriaID = 41139}
	missions[1891] = {AchievementID = 12896, CriteriaID = 41142}
	missions[1896] = {AchievementID = 12896, CriteriaID = 41143}
	missions[1897] = {AchievementID = 12896, CriteriaID = 41144}
	missions[1898] = {AchievementID = 12896, CriteriaID = 41145}
	missions[1899] = {AchievementID = 12896, CriteriaID = 41146}
	missions[1905] = {AchievementID = 12896, CriteriaID = 41147}
	missions[1906] = {AchievementID = 12896, CriteriaID = 41148}
	missions[1913] = {AchievementID = 12896, CriteriaID = 41149}
	missions[1917] = {AchievementID = 12896, CriteriaID = 41150}
	missions[1918] = {AchievementID = 12896, CriteriaID = 41151}
	
	missions[1883] = {AchievementID = 12898, CriteriaID = 41176}
	missions[1884] = {AchievementID = 12898, CriteriaID = 41177}
	missions[1888] = {AchievementID = 12898, CriteriaID = 41178}
	missions[1889] = {AchievementID = 12898, CriteriaID = 41179}
	missions[1894] = {AchievementID = 12898, CriteriaID = 41180}
	missions[1895] = {AchievementID = 12898, CriteriaID = 41181}
	missions[1903] = {AchievementID = 12898, CriteriaID = 41182}
	missions[1904] = {AchievementID = 12898, CriteriaID = 41183}
	missions[1909] = {AchievementID = 12898, CriteriaID = 41184}
	missions[1911] = {AchievementID = 12898, CriteriaID = 41185}
	missions[1912] = {AchievementID = 12898, CriteriaID = 41186}
	missions[1914] = {AchievementID = 12898, CriteriaID = 41187}
	missions[1915] = {AchievementID = 12898, CriteriaID = 41188}
	
	missions[1858] = {AchievementID = 12899, CriteriaID = 41189}
	missions[1866] = {AchievementID = 12899, CriteriaID = 41190}
	missions[1882] = {AchievementID = 12899, CriteriaID = 41191}
	missions[1887] = {AchievementID = 12899, CriteriaID = 41192}
	missions[1892] = {AchievementID = 12899, CriteriaID = 41193}
	missions[1893] = {AchievementID = 12899, CriteriaID = 41194}
	missions[1900] = {AchievementID = 12899, CriteriaID = 41195}
	missions[1901] = {AchievementID = 12899, CriteriaID = 41196}
	missions[1902] = {AchievementID = 12899, CriteriaID = 41197}
	missions[1907] = {AchievementID = 12899, CriteriaID = 41198}
	missions[1908] = {AchievementID = 12899, CriteriaID = 41199}
	missions[1910] = {AchievementID = 12899, CriteriaID = 41200}
	missions[1916] = {AchievementID = 12899, CriteriaID = 41201}
	
	missions[1929] = {AchievementID = 12867, CriteriaID = 41096}
	missions[1923] = {AchievementID = 12867, CriteriaID = 41097}
	missions[1934] = {AchievementID = 12867, CriteriaID = 41098}
	missions[1935] = {AchievementID = 12867, CriteriaID = 41099}
	missions[1879] = {AchievementID = 12867, CriteriaID = 41100}
	missions[1959] = {AchievementID = 12867, CriteriaID = 41101}
	missions[1937] = {AchievementID = 12867, CriteriaID = 41102}
	missions[1936] = {AchievementID = 12867, CriteriaID = 41103}
	missions[1943] = {AchievementID = 12867, CriteriaID = 41104}
	missions[1951] = {AchievementID = 12867, CriteriaID = 41105}
	missions[1944] = {AchievementID = 12867, CriteriaID = 41106}
	missions[1955] = {AchievementID = 12867, CriteriaID = 41107}
	missions[1956] = {AchievementID = 12867, CriteriaID = 41108}
	
	missions[1921] = {AchievementID = 12869, CriteriaID = 41163}
	missions[1922] = {AchievementID = 12869, CriteriaID = 41164}
	missions[1927] = {AchievementID = 12869, CriteriaID = 41165}
	missions[1928] = {AchievementID = 12869, CriteriaID = 41166}
	missions[1932] = {AchievementID = 12869, CriteriaID = 41167}
	missions[1933] = {AchievementID = 12869, CriteriaID = 41168}
	missions[1941] = {AchievementID = 12869, CriteriaID = 41169}
	missions[1942] = {AchievementID = 12869, CriteriaID = 41170}
	missions[1946] = {AchievementID = 12869, CriteriaID = 41171}
	missions[1949] = {AchievementID = 12869, CriteriaID = 41172}
	missions[1950] = {AchievementID = 12869, CriteriaID = 41173}
	missions[1952] = {AchievementID = 12869, CriteriaID = 41174}
	missions[1953] = {AchievementID = 12869, CriteriaID = 41175}
	
	missions[1919] = {AchievementID = 12870, CriteriaID = 41202}
	missions[1920] = {AchievementID = 12870, CriteriaID = 41203}
	missions[1925] = {AchievementID = 12870, CriteriaID = 41204}
	missions[1926] = {AchievementID = 12870, CriteriaID = 41205}
	missions[1930] = {AchievementID = 12870, CriteriaID = 41206}
	missions[1931] = {AchievementID = 12870, CriteriaID = 41207}
	missions[1938] = {AchievementID = 12870, CriteriaID = 41208}
	missions[1939] = {AchievementID = 12870, CriteriaID = 41209}
	missions[1940] = {AchievementID = 12870, CriteriaID = 41210}
	missions[1945] = {AchievementID = 12870, CriteriaID = 41211}
	missions[1947] = {AchievementID = 12870, CriteriaID = 41212}
	missions[1948] = {AchievementID = 12870, CriteriaID = 41213}
	missions[1954] = {AchievementID = 12870, CriteriaID = 41214}
	--]]
	
	--new!
	this.private.AchCritToMissionID =
	{
		[12867] = 
		{
			[41096] = 1929,
			[41097] = 1923,
			[41098] = 1934,
			[41099] = 1935,
			[41100] = 1879,
			[41101] = 1959,
			[41102] = 1937,
			[41103] = 1936,
			[41104] = 1943,
			[41105] = 1951,
			[41106] = 1944,
			[41107] = 1955,
			[41108] = 1956
		},
		[12869] =
		{
			[41163] = 1921,
			[41164] = 1922,
			[41165] = 1927,
			[41166] = 1928,
			[41167] = 1932,
			[41168] = 1933,
			[41169] = 1941,
			[41170] = 1942,
			[41171] = 1946,
			[41172] = 1949,
			[41173] = 1950,
			[41174] = 1952,
			[41175] = 1953
		},
		[12870] =
		{
			[41202] = 1919,
			[41203] = 1920,
			[41204] = 1925,
			[41205] = 1926,
			[41206] = 1930,
			[41207] = 1931,
			[41208] = 1938,
			[41209] = 1939,
			[41210] = 1940,
			[41211] = 1945,
			[41212] = 1947,
			[41213] = 1948,
			[41214] = 1954
		},
		[12896] =
		{
			[41140] = 1885,
			[41141] = 1886,
			[41139] = 1890,
			[41142] = 1891,
			[41143] = 1896,
			[41144] = 1897,
			[41145] = 1898,
			[41146] = 1899,
			[41147] = 1905,
			[41148] = 1906,
			[41149] = 1913,
			[41150] = 1917,
			[41151] = 1918
		},
		[12898] =
		{
			[41176] = 1883,
			[41177] = 1884,
			[41178] = 1888,
			[41179] = 1889,
			[41180] = 1894,
			[41181] = 1895,
			[41182] = 1903,
			[41183] = 1904,
			[41184] = 1909,
			[41185] = 1911,
			[41186] = 1912,
			[41187] = 1914,
			[41188] = 1915
		},
		[12899] =
		{
			[41189] = 1858,
			[41190] = 1866,
			[41191] = 1882,
			[41192] = 1887,
			[41193] = 1892,
			[41194] = 1893,
			[41195] = 1900,
			[41196] = 1901,
			[41197] = 1902,
			[41198] = 1907,
			[41199] = 1908,
			[41200] = 1910,
			[41201] = 1916
		}
	}
	
	local MyFaction = lib.unit.GetPlayerFaction()
	this.private.achievementIDs = {}
	if(MyFaction == "Alliance") then
		this.private.achievementIDs[1] = 12896
		this.private.achievementIDs[2] = 12898
		this.private.achievementIDs[3] = 12899
	else
		this.private.achievementIDs[1] = 12867
		this.private.achievementIDs[2] = 12869
		this.private.achievementIDs[3] = 12870
	end
	
	for _,ID in pairs(this.private.achievementIDs) do
		lib.achievement.AddByID(ID)
	end
	
	return
end

--this function is only for testing
function this.private.ListAchievements()
	this.private.Validate()
	
	local out = lib.chat.output
	
	for _,ID in pairs(this.private.achievementIDs) do
		local complete = select(13,GetAchievementInfo(ID))
		if(complete) then
			out.StoreCompleted(GetAchievementLink(ID))
		else
			out.StoreTodo(GetAchievementLink(ID))
		end
	end
	
	return
end

--[[
function this.private.ListMissions()
	this.private.Validate()
	
	local out = lib.chat.output	
	local AllMissions = lib.garrison.BFA.GetMissions()
	
	if(AllMissions == nil) then
		out.StoreTodo("not unlocked on this character.")
		return
	end
	
	if(lib.table.isEmpty(AllMissions)) then
		out.StoreDone("no missions available.")
		return
	end
	
	for _,Mission in pairs(AllMissions) do
		local AchMission = this.private.missions[Mission.ID]
		
		if(AchMission == nil) then
			out.StoreDone(Mission.Name.." (not part of any achievement)")
		else
			local Ach = lib.achievement.GetByID(AchMission.AchievementID)
			local Completed = Ach.CriteriaByID[AchMission.CriteriaID].IsCompleted
		
			if(Completed == true) then
				out.StoreCompleted(Mission.Name.." << "..Ach.Link)
			else
				out.StoreTodo(Mission.Name.." << "..Ach.Link.." << expires in: "..Mission.TimeToExpire)
			end
		end
	end
	
	return
end
--]]

function this.private.GetAvailableMissionByID(MissionID)
	this.private.Validate()
	
	for _,Mission in pairs(this.private.AllMissions) do
		if(Mission.ID == MissionID) then
			return Mission
		end
	end
	
	return nil
end

function this.private.IsMissingMissionUp(AchID)
	this.private.Validate()
	
	local AchData = lib.achievement.GetByID(AchID)
	
	for CritID,Crit in pairs(AchData.CriteriaByID) do
		if(Crit.IsCompleted == false) then
			local MissionID = this.private.AchCritToMissionID[AchID][CritID]
			if(this.private.GetAvailableMissionByID(MissionID) ~= nil) then
				return true
			end
		end
	end
	
	return false
end

function this.private.Update()
	this.private.Validate()
	
	for _,ID in pairs(this.private.achievementIDs) do
		lib.achievement.UpdateByID(ID)
	end
	
	lib.garrison.BFA.Update()
	this.private.AllMissions = lib.garrison.BFA.GetMissions()
	

	local out = lib.chat.output
	out.ClearBuffer()
	
	--test if this character hass access to missions
	if(this.private.AllMissions == nil) then
		return
	end
	
	for _,AchID in pairs(this.private.achievementIDs) do
		local AchData = lib.achievement.GetByID(AchID)
		
		if(AchData.IsCompleted == true) then
			out.StoreCompleted(AchData.Link)
		else
			local MissingMissionAvailable = this.private.IsMissingMissionUp(AchID)
			if(MissingMissionAvailable == false) then
				out.StoreDone(AchData.Link)
			else
				out.StoreTodo(AchData.Link)
			end
			
			for CritID,CritData in pairs(AchData.CriteriaByID) do
				if(CritData.IsCompleted == false) then
					--check if this mission is up
					local Mission = this.private.GetAvailableMissionByID(this.private.AchCritToMissionID[AchID][CritID])
					if(Mission == nil) then
						out.StoreDone(CritData.Name)
					else
						out.StoreTodo(Mission.Name)
					end
				else
					out.StoreCompleted(CritData.Name)
				end
			end
		end		
	end

	return
end

function this.CheckStatus()
	this.private.Validate()
	
	this.private.Update()
	if(lib.chat.output.GetNumLines() == 0) then
		return false
	end
	
	return true
end

function this.Script()
	this.private.Validate()
	
	this.private.Update()
	lib.chat.output.PrintModule(this.Name)
	
	return
end

mod[#mod+1] =
{
	CheckStatus	= this.CheckStatus,
	Text		= this.Name,
	Script		= this.Script
}
