if(ThingsToDo2 == nil) then
	ThingsToDo2 = {}
end
local ttd2 = ThingsToDo2

if(ttd2.lib == nil) then
	ttd2.lib = {}
end
local lib = ThingsToDo2.lib

lib.keystone = {}
local this = lib.keystone

function this.IsRewardChestAvailable()
	return C_MythicPlus.IsWeeklyRewardAvailable()
end

function this.GetCurrentWeekBest()
	local WeeklyBest = C_MythicPlus.GetWeeklyChestRewardLevel()
	return WeeklyBest
end

function this.GetLastWeekBest()
	local _,WeeklyBest = C_MythicPlus.GetLastWeeklyBestInformation()
	return WeeklyBest
end

function this.Update()
	--these Updates are expensive, that's why they should be called manually
	C_MythicPlus.RequestRewards()
	C_MythicPlus.RequestMapInfo()
	C_MythicPlus.RequestCurrentAffixes()
	return
end
